import unittest
import unittest.mock

class HPackratParseBreakpointStop(unittest.TestCase):
	def setUp(self):
		self.tlp_patcher = unittest.mock.patch('__main__.top_level_parse')
		self.tlp_mock_class = self.tlp_patcher.start()
		self.bp_patcher = unittest.mock.patch.object(HPackratParseBreakpoint, '__init__', return_value=None )
		self.bp_mock_class = self.bp_patcher.start()
		self.hppbp = HPackratParseBreakpoint('main')

	def tearDown(self):
		self.bp_patcher.stop()
		self.tlp_patcher.stop()

	def test_stop(self):
		self.hppbp.stop()
		self.assertTrue(self.tlp_mock_class.enter_h_packrat_parse.called)

#TODO: move to BreakpointManager, mock out breakpoint
#class PerformLowlevelParseRetBreakpointCreated(unittest.TestCase):
#	def test_breakpoint_is_at_ret(self):
#		breakpoint_loc = int(perform_lowlevel_parse_ret.location.lstrip("*"), 16)
#		arch = gdb.selected_frame().architecture()
#		disassembled_ins = arch.disassemble(breakpoint_loc)
#		ins = disassembled_ins[0]['asm'].split(" ")[0]

#		self.assertIn(ins, ["ret", "retq"])

#	def test_not_pending(self):
#		self.assertFalse(perform_lowlevel_parse_ret.pending)

class PerformLowLevelParseRetBreakpointStop(unittest.TestCase):
	def setUp(self):
		self.tlp_patcher = unittest.mock.patch('__main__.top_level_parse')
		self.tlp_mock_class = self.tlp_patcher.start()
		self.bp_patcher = unittest.mock.patch.object(PerformLowLevelParseRetBreakpoint, '__init__', return_value=None )
		self.bp_mock_class = self.bp_patcher.start()
		self.plrbp = PerformLowLevelParseRetBreakpoint("main")

	def tearDown(self):
		self.bp_patcher.stop()
		self.tlp_patcher.stop() #TODO: make sure we unpatch even if exceptions

	def test_stop(self):
		self.plrbp.stop()
		self.assertTrue(self.tlp_mock_class.return_from_perform_lowlevel_parse.called)

#class HPackratParseRetBreakpointCreated(unittest.TestCase):
#	def test_breakpoint_is_at_ret(self):
#		breakpoint_loc = int(h_packrat_parse_ret.location.lstrip("*"), 16)
#		arch = gdb.selected_frame().architecture()
#		disassembled_ins = arch.disassemble(breakpoint_loc)
#		ins = disassembled_ins[0]['asm'].split(" ")[0]

#		self.assertIn(ins, ["ret", "retq"])

#	def test_not_pending(self):
#		self.assertFalse(h_packrat_parse_ret.pending)

class HPackratParseRetBreakpointStop(unittest.TestCase):
	def setUp(self):
		self.tlp_patcher = unittest.mock.patch('__main__.top_level_parse')
		self.tlp_mock_class = self.tlp_patcher.start()
		self.bp_patcher = unittest.mock.patch.object(HPackratParseRetBreakpoint, '__init__', return_value=None )
		self.bp_mock_class = self.bp_patcher.start()
		self.hpprbp = HPackratParseRetBreakpoint("main")

	def tearDown(self):
		self.bp_patcher.stop()
		self.tlp_patcher.stop()

	def test_stop(self):
		self.hpprbp.stop()
		self.assertTrue(self.tlp_mock_class.return_from_h_packrat_parse.called)
